import sys
import pymongo
import zulip
import ldap
from room_functions import load_rocketchat_rooms
from settings import MONGO_HOST, MONGO_PORT, ZULIPRC_PATH, ZULIP_INSECURE, LDAP_URI, ROCKET_CHAT_ROOM_TYPES
from room_functions import select_room, select_stream
from user_functions import solve_profile_mapping, map_user
from helpers import read_curses_string
import curses
import datetime

# Main function wrapped into ncurses window
def main(cw):
    # Connections
    zulip_client = zulip.Client(config_file=ZULIPRC_PATH, insecure=ZULIP_INSECURE)
    ldap_connection = ldap.initialize(LDAP_URI)
    client = pymongo.MongoClient(MONGO_HOST, MONGO_PORT)
    cw.scrollok(True)

    # Load rooms
    # room = select_room(load_rocketchat_rooms(client.parties), cw)
    # cw.clear()
    # cw.addstr("Selected room:\n")
    # cw.addstr(f"_id: {room['_id']},"
    #           f"name: {room.get('name')},"
    #           f"type: {ROCKET_CHAT_ROOM_TYPES[room['t']]}\n")
    # if (room['t'] !='c'):
    #     cw.addstr("Can't import other chat rooms than those with type 'c'\n")
    #     cw.addstr("Press any key to exit\n")
    #     cw.getch()
    #     sys.exit(1)
    # cw.addstr("\n! Detecting and maping users, this will take some time !\n")
    # cw.refresh()
    room = {"_id": 'GENERAL', "name": "GENERAL"}
    #
    # # User mapping
    # users = client.parties.rocketchat_message.distinct("u", {"rid":room['_id']})
    # user_profiles = []
    # for (key, user) in enumerate(users):
    #     user = client.parties.users.find_one({'_id': user['_id']})
    #     user = map_user(user, zulip_client, ldap_connection)
    #     user['local_id'] = key
    #     user_profiles.append(user)
    user_profiles = [{'_id': '4bXbRoJy2CpY7krSu', 'createdAt': datetime.datetime(2017, 8, 18, 12, 2, 28, 715000), 'services': {'password': {'bcrypt': '$2a$10$ezDefS0SKpjHYTvfoX0Kp.fQGqJrTAzd/ZTV43zljV5XaBjbS3ERe'}, 'resume': {'loginTokens': []}}, 'username': 'Oliver', 'emails': [{'address': 'oholschke@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Oliver Holschke', '_updatedAt': datetime.datetime(2019, 4, 16, 9, 40, 45, 240000), 'roles': ['user'], 'lastLogin': datetime.datetime(2019, 3, 28, 19, 15, 0, 421000), 'statusConnection': 'offline', 'utcOffset': 1, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Oliver Holschke,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 0}, {'_id': '6YZboSmMHktD3JDco', 'createdAt': datetime.datetime(2017, 8, 17, 11, 17, 16, 790000), 'services': {'password': {'bcrypt': '$2b$10$9R6/bM6mxmmeWMsEE0pIZebtSfTHGGYnMVrsk8/mAFUsFpP452LeW'}, 'resume': {'loginTokens': [{'hashedToken': 'vF7ON+FQ75tk30i0NWyAxmwI4nU4FhkF6Nmmos/gUMs='}, {'when': datetime.datetime(2020, 3, 27, 13, 7, 6, 127000), 'hashedToken': 'C37IiI4Ax/UXS3GTpP06bDQKyJ5O1bNMOII5mjZAAvc='}, {'when': datetime.datetime(2020, 4, 17, 6, 50, 27, 73000), 'hashedToken': '61XLizgArd7/ATYuHVhDa0OGNnuGJfZtDgTcsydSiXI='}, {'when': datetime.datetime(2020, 5, 11, 12, 14, 42, 697000), 'hashedToken': 'w76NrLYvNR/jPVPQMKYxzAK7LOxKspIdZ3H0j+h/yqo='}]}, 'ldap': {'id': '61766f67656c', 'idAttribute': 'uid'}}, 'username': 'avogel', 'emails': [{'address': 'avogel@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Arne Vogel', '_updatedAt': datetime.datetime(2020, 6, 17, 12, 34, 7, 125000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 17, 12, 33, 59, 823000), 'statusConnection': 'offline', 'utcOffset': 2, 'settings': {'profile': {}, 'preferences': {'newRoomNotification': 'none', 'newMessageNotification': 'none', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'avatarOrigin': 'upload', 'requirePasswordChange': False, 'language': '', 'ldap': True, 'mapped_on': 'ldap:cn=Arne Vogel,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 1}, {'_id': '9kHWRcrtX3MkBghsk', 'createdAt': datetime.datetime(2017, 8, 30, 9, 12, 56, 587000), 'services': {'password': {'bcrypt': '$2a$10$YbwZWBwwPEINWer5EOy11.ksmK45zp5JbwsUrm3Vmr4R0F/o4zB36'}, 'resume': {'loginTokens': []}}, 'username': 'Deniz', 'emails': [{'address': 'dbahadir@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Deniz Bahadir', '_updatedAt': datetime.datetime(2020, 5, 31, 9, 51, 29, 283000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 5, 25, 14, 56, 9, 810000), 'statusConnection': 'offline', 'utcOffset': 2, 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': [], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category'}}, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Deniz Bahadir,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 2}, {'_id': 'AAPDaCDFJmKeR7zuh', 'createdAt': datetime.datetime(2017, 10, 10, 10, 57, 13, 221000), 'services': {'password': {'bcrypt': '$2a$10$bVl//BZauSR5wIAQz.vHYuOy.gvE4jq2kKYeslBfCQUhrV.0HKDCW'}, 'resume': {'loginTokens': []}}, 'username': 'Lisa', 'emails': [{'address': 'lkruse@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Lisa Kruse', '_updatedAt': datetime.datetime(2019, 6, 11, 7, 15, 57, 378000), 'roles': ['user'], 'lastLogin': datetime.datetime(2019, 4, 12, 10, 32, 50, 230000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Lisa Kruse,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 3}, {'_id': 'B6tSdyBJ5P7w5ADfi', 'createdAt': datetime.datetime(2017, 7, 21, 19, 37, 30, 889000), 'services': {'password': {'bcrypt': '$2a$10$OYATXYf7SqgcCx.SafVrWOJHNLYLjE1nA8gUb9SjEAFC1Z7Oeh3zO'}, 'resume': {'loginTokens': []}}, 'username': 'max', 'emails': [{'address': 'devnulll@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': False, 'name': 'Max Zwerenz', '_updatedAt': datetime.datetime(2018, 7, 5, 23, 17, 47, 376000), 'roles': ['user'], 'lastLogin': datetime.datetime(2017, 8, 2, 14, 4, 37, 648000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'mapped_on': None, 'local_id': 4}, {'_id': 'FNoqznDddTrjXggxc', 'createdAt': datetime.datetime(2019, 3, 4, 12, 47, 33, 567000), 'services': {'password': {'bcrypt': '$2b$10$MkdFO55N1d9Ze5mM5F0qGuOMHA1aw/tyMBeEUUnqvdbP7Av/FW.8C'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 25, 6, 52, 14, 504000), 'hashedToken': 'Gb6evgnWZgtKzNFitPDFfd+PVyHZBI+dG2lEB+bpktk='}]}, 'ldap': {'id': '64726562656c6f', 'idAttribute': 'uid'}}, 'username': 'drebelo', 'emails': [{'address': 'drebelo@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, '_updatedAt': datetime.datetime(2020, 6, 23, 6, 32, 28, 642000), 'roles': ['user'], 'name': 'Diana Rebelo Da Costa', 'settings': {}, 'lastLogin': datetime.datetime(2020, 6, 23, 6, 32, 28, 598000), 'statusConnection': 'online', 'utcOffset': 2, 'requirePasswordChange': False, 'ldap': True, 'statusDefault': 'offline', 'mapped_on': 'ldap:cn=Diana Rebelo da Costa,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 5}, {'_id': 'GWomsgueAb7Liy2Wx', 'createdAt': datetime.datetime(2020, 3, 6, 15, 9, 13, 200000), 'services': {'password': {'bcrypt': '$2b$10$XmX7MVAJLLieoRz9uDHRD.HPFsRCCKUqtBX4y0R5LFcbAQBDK2wAO'}, 'ldap': {'id': '74686f65686c6967', 'idAttribute': 'uid'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 6, 11, 10, 1, 816000), 'hashedToken': '0MfuSyRhFQruBQk+kmITmY2c153VOHuViLAZsXgJdYU='}, {'when': datetime.datetime(2020, 4, 21, 7, 14, 0, 157000), 'hashedToken': 'EOqTCFc6DbXxz7F6k30iHLs53KpRBWR6lUUVe4FbcGw='}, {'when': datetime.datetime(2020, 5, 14, 8, 52, 46, 992000), 'hashedToken': 'QTi7gp9yMPTmSNuhLsd5IWyGPKPXgxLCI7eCijTO+JY='}]}}, 'username': 'thoehlig', 'emails': [{'address': 'thoehlig@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, '_updatedAt': datetime.datetime(2020, 6, 23, 11, 32, 3, 49000), 'roles': ['user'], 'name': 'Thomas Höhlig', 'requirePasswordChange': False, 'settings': {}, 'ldap': True, 'lastLogin': datetime.datetime(2020, 6, 23, 11, 32, 2, 979000), 'statusConnection': 'online', 'utcOffset': 2, 'statusText': '', 'mapped_on': 'ldap:cn=Thomas Höhlig,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 6}, {'_id': 'Tf9jc9CsGoGqPRgJn', 'createdAt': datetime.datetime(2017, 8, 30, 9, 12, 25, 751000), 'services': {'password': {'bcrypt': '$2a$10$PuE1cpcBEYB01I7rQ06g3unATtpk/LZxCM.RsoSGY.yTubV4PaDg.'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 12, 12, 55, 53, 626000), 'hashedToken': 'aka6ezfy0uToghklSQjADb64ZygNIpGa0nt9xnj33Fs='}, {'when': datetime.datetime(2020, 5, 12, 14, 45, 50, 46000), 'hashedToken': 'DByrNDZugwfivkk7W0X5f+8vegK2PIma7kckyf2cJBU='}, {'when': datetime.datetime(2020, 5, 14, 8, 50, 34, 513000), 'hashedToken': 'Z7iVddKlBTe/RENTZolHRwkUfSSpny3mWo0AztHMkW8='}, {'when': datetime.datetime(2020, 5, 20, 12, 34, 4, 647000), 'hashedToken': 'WJIaugnN+ywUQfW+KKVhKJtifUg2z1Gl+ej4s4U9GKs='}]}}, 'username': 'Andrea', 'emails': [{'address': 'ajablonski@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Andrea Jablonski', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 6, 12, 169000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 11, 0, 5, 625000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'statusText': '', 'settings': {'profile': {}}, 'avatarOrigin': 'upload', 'statusDefault': 'online', 'mapped_on': 'ldap:cn=Andrea Jablonski,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 7}, {'_id': 'XB6cpvDpa38hNALsE', 'createdAt': datetime.datetime(2018, 7, 2, 12, 29, 16, 163000), 'services': {'password': {'bcrypt': '$2b$10$iY0u.VOiEDubzsFUzYCaZ.4CErmZI8LM79ovBj9zSUhLUOlWmWJYK'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 7, 7, 55, 6, 983000), 'hashedToken': '9UD5s6n9gMlACDLX4GUWXCXTbcKx32GYIobNNg4crWA='}, {'when': datetime.datetime(2020, 4, 17, 17, 0, 46, 927000), 'hashedToken': 'OF1zPXYZ9sy6q43cfh1dRqRTP0tX4BSBK1UEfeRSF90='}]}, 'ldap': {'id': '61726f656d6572', 'idAttribute': 'uid'}}, 'username': 'aroemer', 'emails': [{'address': 'aroemer@benocs.com', 'verified': True}], 'type': 'user', 'status': 'away', 'active': True, 'name': 'Axel Roemer', '_updatedAt': datetime.datetime(2020, 6, 23, 12, 8, 30, 860000), 'roles': ['user'], 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'nothing', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarShowDiscussion': True, 'sidebarViewMode': 'condensed', 'sidebarHideAvatar': False, 'sidebarShowFavorites': True, 'sidebarShowUnread': True}, 'profile': {}}, 'lastLogin': datetime.datetime(2020, 6, 23, 9, 0, 14, 959000), 'statusConnection': 'away', 'utcOffset': 2, 'language': '', 'statusDefault': 'online', 'requirePasswordChange': False, 'ldap': True, 'statusText': '', 'avatarOrigin': 'upload', 'mapped_on': 'ldap:cn=Axel Römer,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 8}, {'_id': 'au3sJqxqDy7xiMJsW', 'createdAt': datetime.datetime(2017, 8, 30, 9, 13, 22, 636000), 'services': {'password': {'bcrypt': '$2a$10$AzDx2SPL7mhcrmEHDSmKluQiK6MKey.vKL96zI/2AO7vSmRYlvh7G'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 29, 7, 52, 38, 364000), 'hashedToken': 'lyVBfPJenVHQ9M7j4HneW+OHb5na+FyBSbNvXOHb5fk='}, {'when': datetime.datetime(2020, 6, 18, 14, 51, 37, 705000), 'hashedToken': 'pytYazfo27ox16iieQl8WBMYfoLQK6BJYs4nTkMtGVE='}, {'when': datetime.datetime(2020, 6, 22, 6, 22, 5, 348000), 'hashedToken': 'wL6N8seIjxK8uXPpIlB76zvOjbGH1FBcDlPd7/80NA4='}, {'when': datetime.datetime(2020, 6, 22, 11, 15, 23, 744000), 'hashedToken': 'gpEg0CdZRae0oAMPbx54g6JilAjKvTBPiM4W1iKWxUA='}]}}, 'username': 'Hans', 'emails': [{'address': 'hseidel@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Hans Seidel', '_updatedAt': datetime.datetime(2020, 6, 23, 7, 57, 57, 353000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 7, 57, 57, 264000), 'statusConnection': 'online', 'utcOffset': 2, 'requirePasswordChange': False, 'settings': {'preferences': {'sidebarViewMode': 'medium', 'sidebarSortby': 'alphabetical', 'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'sidebarShowDiscussion': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'language': '', 'mapped_on': 'ldap:cn=Hans Seidel,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 9}, {'_id': 'cYn5zhNq2sQWrTssa', 'createdAt': datetime.datetime(2017, 8, 30, 9, 14, 6, 495000), 'services': {'password': {'bcrypt': '$2b$10$OCVjSHSIPjWbvce3Df.l0OfASV7pEsZPelcWyZCpSexiVOC5.uU9y'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 5, 8, 29, 36, 543000), 'hashedToken': 'TQJ+HDusTNBJtXi9nT+rZDBQItSaFC2sknXFauC3YNA='}, {'when': datetime.datetime(2020, 5, 14, 11, 17, 14, 604000), 'hashedToken': '9tFnIT2+Q0AULAVXnD5/XgV6TSvYlQms3h6G7VSYJB8='}, {'when': datetime.datetime(2020, 5, 14, 11, 36, 20, 946000), 'hashedToken': 'WxzcjSFi/1ePSBHcXdrPYvN3qntp3T8ioLCFhH8O1Nk='}, {'when': datetime.datetime(2020, 6, 9, 8, 24, 49, 859000), 'hashedToken': 'tDIZra74VmwXOAojgScIT1H3tGa+1ceHF9vIKmJkj6c='}]}, 'ldap': {'id': '6d6b616c69737a616e', 'idAttribute': 'uid'}}, 'username': 'mkaliszan', 'emails': [{'address': 'mkaliszan@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Michał Kaliszan', '_updatedAt': datetime.datetime(2020, 6, 23, 7, 57, 56, 460000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 7, 57, 56, 412000), 'statusConnection': 'online', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'roomsListExhibitionMode': 'category', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'all', 'mobileNotifications': 'all', 'audioNotificationValue':' nan', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': [], 'sendOnEnter': 'normal', 'muteFocusedConversations': True, 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'requirePasswordChange': False, 'statusDefault': 'online', 'ldap': True, 'mapped_on': 'ldap:cn=Michal Kaliszan,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 10}, {'_id': 'gsKLNsqdhodg9k5km', 'createdAt': datetime.datetime(2017, 8, 15, 14, 31, 0, 57000), 'services': {'password': {'bcrypt': '$2b$10$1YPYPXeZZsqPoj1fWpWDk.ZMh.fvj6jtG8aXxMO54epOiIGXiXAiC'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 25, 10, 1, 53, 861000), 'hashedToken': 'bVzOtnvPXWyXTF5J4Xl4549PEkhpPKP+gpnbxzYyN3g='}]}}, 'username': 'epujol', 'emails': [{'address': 'enric@benocs.com', 'verified': True}], 'type': 'user', 'status': 'away', 'active': True, 'name': 'Enric Pujol', '_updatedAt': datetime.datetime(2020, 6, 23, 12, 2, 31, 353000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 9, 12, 7, 882000), 'statusConnection': 'away', 'utcOffset': 2, 'statusDefault': 'online', 'requirePasswordChange': False, 'ldap': True, 'settings': {'preferences': {'sidebarViewMode': 'condensed', 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}], 'autoImageLoad': True, 'collapseMediaByDefault': False, 'convertAsciiEmoji': True, 'desktopNotificationDuration': 0, 'desktopNotificationRequireInteraction': False, 'desktopNotifications': 'mentions', 'emailNotificationMode': 'nothing', 'enableAutoAway': False, 'hideAvatars': False, 'hideFlexTab': False, 'hideRoles': False, 'hideUsernames': False, 'highlights': [], 'idleTimeLimit': 300, 'language': '', 'messageViewMode': 0, 'mobileNotifications': 'all', 'muteFocusedConversations': True, 'newMessageNotification': 'chime', 'newRoomNotification': 'door', 'notificationsSoundVolume': 100, 'saveMobileBandwidth': True, 'sendOnEnter': 'normal', 'sidebarHideAvatar': False, 'sidebarShowDiscussion': True, 'unreadAlert': False, 'useEmojis': True}}, 'language': '', 'mapped_on': 'ldap:cn=Enric Pujol,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 11}, {'_id': 'ivwNbZBZwFKkB9F82', 'createdAt': datetime.datetime(2018, 8, 1, 13, 49, 42, 521000), 'services': {'password': {'bcrypt': '$2b$10$ZRgf/dyR/Fnmsl0y2s.pJe2Dx4DB.CUcZCk9Yv939lqPqZfVKEn4S'}, 'resume': {'loginTokens': [{'hashedToken': 'e+gpMrRSoKraATt1nvGN0lO23Hl5TH8mNFqzhaRsPUo='}, {'when': datetime.datetime(2020, 3, 31, 11, 8, 2, 801000), 'hashedToken': 'k7cUTNoiDGfmsGQ5rOgz4w49QQMGb88TElZBRMc4cy4='}, {'when': datetime.datetime(2020, 5, 7, 8, 48, 38, 370000), 'hashedToken': 'bqWVpYZ/uFT6Hq3TyZBKxZ8gHwJxTgK8vwLhT9itqB8='}, {'when': datetime.datetime(2020, 5, 19, 6, 25, 50, 219000), 'hashedToken': '0eBVJxNPTy3G9cZMqPp8pTrFtutKtvc8H7hX3RHmi3I='}, {'when': datetime.datetime(2020, 6, 8, 8, 14, 7, 195000), 'hashedToken': 'S3rkrkZBJI91T35l72oadUSznpyU8kLSPr7SdfTfWrA='}, {'when': datetime.datetime(2020, 6, 11, 12, 39, 47, 388000), 'hashedToken': 'ByPJ0csi90TltJfaIxVA3X7WaDP2JdAydFs/GJGQzjk='}, {'when': datetime.datetime(2020, 6, 22, 8, 54, 35, 352000), 'hashedToken': '1V/a0DD1P4BIe+dn0L88iXD5n6ehjpHTKRLCyaP03mM='}]}, 'ldap': {'id': '6f6b6f6c696e', 'idAttribute': 'uid'}}, 'username': 'okolin', 'emails': [{'address': 'okolin@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Ondrej Kolin', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 30, 16, 703000), 'roles': ['user', 'admin', 'bot'], 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarViewMode': 'medium'}}, 'lastLogin': datetime.datetime(2020, 6, 23, 11, 22, 52, 591000), 'statusConnection': 'offline', 'utcOffset': 2, 'language': '', 'ldap': True, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'statusDefault': 'online', 'mapped_on': 'zulip:okolin@benocs.com', 'local_id': 12}, {'_id': 'j2Gr8fWHAJE33Wnvp', 'createdAt': datetime.datetime(2018, 8, 31, 8, 35, 7, 526000), 'services': {'password': {'bcrypt': '$2b$10$M3zlYtzbs4/G85K9JrA/jurc3kMimGpKxPV4EWjdfjWdzqzqtQywS'}, 'resume': {'loginTokens': [{'hashedToken': 'GJUYwlO9WAomywHJq55z/hXbwh9Uk28oPpXhal0yX6E='}, {'when': datetime.datetime(2020, 3, 26, 7, 38, 12, 337000), 'hashedToken': 'VX66x54ojeXk2T81yFrOlELlF5ZpZN+5GhNGQENa+Vs='}, {'when': datetime.datetime(2020, 4, 27, 8, 37, 28, 490000), 'hashedToken': 'hISbmEPoxJX/krLNx8aqt4LNtCU3i3erIo05vYRA4F8='}]}}, 'username': 'Stephan', 'emails': [{'address': 'sschroeder@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Stephan Schröder', '_updatedAt': datetime.datetime(2020, 6, 23, 9, 13, 0, 241000), 'roles': ['user'], 'settings': {'preferences': {'sidebarViewMode': 'condensed', 'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'nothing', 'desktopNotificationDuration': 0, 'desktopNotifications': 'all', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarShowUnread': True}}, 'lastLogin': datetime.datetime(2020, 6, 23, 9, 13, 0, 174000), 'statusConnection': 'online', 'utcOffset': 2, 'language': '', 'avatarOrigin': 'upload', 'statusDefault': 'online', 'mapped_on': 'ldap:cn=Stephan Schröder,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 13}, {'_id': 'rH2RYKXCBmpy22gQy', 'createdAt': datetime.datetime(2017, 7, 21, 19, 38, 38, 75000), 'services': {'password': {'bcrypt': '$2b$10$mJtAnWzvfb9NwAPRLLzv7OFMfuuau587Tx3JgEGSaTyU5tLM4vcWC'}, 'resume': {'loginTokens': [{'hashedToken': 'WV7JtVZRcUqSektXPraQOmYJbSKk1W65/rPmP8880gI='}, {'when': datetime.datetime(2020, 5, 14, 7, 23, 13, 403000), 'hashedToken': 'ruT4mcUpnqWnnaYxS8717QuehKxmJtRMk2ZWHQsEJr8='}, {'when': datetime.datetime(2020, 5, 26, 17, 35, 48, 512000), 'hashedToken': 'TLMS7UHKs4z8damWaPk+KUFWwpR9hmRb0YHQlCtluPc='}, {'when': datetime.datetime(2020, 6, 17, 13, 2, 48, 258000), 'hashedToken': '7CWQzlUgHBfCThsjIzmHo2kPYaF3pRaC935ElxywWqw='}]}, 'ldap': {'id': '70757262616e696b', 'idAttribute': 'uid'}}, 'username': 'purbanik', 'emails': [{'address': 'purbanik@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Phillip Urbanik', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 45, 16, 778000), 'roles': ['user', 'livechat-manager', 'livechat-agent'], 'lastLogin': datetime.datetime(2020, 6, 23, 11, 45, 16, 727000), 'statusConnection': 'online', 'utcOffset': 2, 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'nothing', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': ['@purbanik', '@phillip'], 'sendOnEnter': 'normal', 'sidebarSortby': 'alphabetical', 'sidebarShowUnread': True, 'sidebarShowFavorites': True, 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarShowDiscussion': True, 'dontAskAgainList': []}}, 'language': 'en', 'requirePasswordChange': False, 'operator': True, 'statusLivechat': 'not-available', 'livechatCount': 30, 'statusDefault': 'online', 'avatarOrigin': 'upload', 'ldap': True, 'mapped_on': 'ldap:cn=Phillip Urbanik,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 14}, {'_id': 'rocket.cat', 'createdAt': datetime.datetime(2017, 7, 21, 15, 44, 51, 957000), 'avatarOrigin': 'upload', 'name': 'Benocs Bot', 'username': 'Benocsbot', 'status': 'offline', 'statusDefault': 'online', 'utcOffset': 1, 'active': True, 'type': 'bot', '_updatedAt': datetime.datetime(2020, 3, 3, 13, 35, 7, 958000), 'roles': ['bot'], 'emails': [{'address': 'benocsbot@benocs.com', 'verified': True}], 'services': {'password': {'bcrypt': '$2a$10$g.Tiq04Or6PKGQ7yRmih4utVaOi0Nhlb3dVh7u.p3mYhmd0.Q8nl.'}, 'resume': {'loginTokens': []}}, 'requirePasswordChange': False, 'lastLogin': datetime.datetime(2018, 5, 24, 2, 1, 20, 985000), 'statusConnection': 'offline', 'mapped_on': None, 'local_id': 15}, {'_id': 'tL97yy2CNRTj2bR2m', 'createdAt': datetime.datetime(2017, 9, 28, 13, 31, 21, 404000), 'services': {'password': {'bcrypt': '$2a$10$Kk0KtVJ7NQ6PuvPVO2PFuuL2ysemx46FGDuA0ZCtfGTv4VAW1BqJq'}, 'resume': {'loginTokens': []}}, 'username': 'junzhe', 'emails': [{'address': 'jun-zhe.lai@cct-ev.de', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Jun-Zhe Lai', '_updatedAt': datetime.datetime(2019, 5, 18, 19, 20, 44, 906000), 'roles': ['guest'], 'lastLogin': datetime.datetime(2019, 3, 25, 14, 0, 41, 670000), 'statusConnection': 'offline', 'utcOffset': 1, 'avatarOrigin': 'url', 'settings': {'preferences': {'sidebarViewMode': 'medium'}}, 'statusDefault': 'busy', 'mapped_on': None, 'local_id': 16}, {'_id': 'tTZrHZ28gWKk7oXDw', 'createdAt': datetime.datetime(2017, 8, 23, 13, 21, 25, 641000), 'services': {'password': {'bcrypt': '$2b$10$nQywJ5uiyCS.8t2nLEGqYOXyKRIuROWHxVGKAcsyYl2fSSalE3PeS'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 7, 13, 2, 32, 93000), 'hashedToken': 'ZuviXpIjtMfAVQp44O5itFxoEfMqLR5q7/3V7cplxDs='}, {'when': datetime.datetime(2020, 5, 14, 11, 39, 11, 327000), 'hashedToken': '5JUqHIi03GnE3kkaczcknoTLyOhR3RzJFijSoovUFnQ='}, {'when': datetime.datetime(2020, 5, 14, 11, 39, 44, 234000), 'hashedToken': '14tA0K5Csa+fGZwHb4fmBmMqX3BoXfVW5vReQ2xhZPk='}, {'when': datetime.datetime(2020, 5, 15, 11, 52, 37, 773000), 'hashedToken': 'H/cA8TkTOu4Ph/Vik1XqhLV5DW1CgDzG878QNbwCNNc='}]}, 'ldap': {'id': '72777574746b65', 'idAttribute': 'uid'}}, 'username': 'rwuttke', 'emails': [{'address': 'robert@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Robert Wuttke', '_updatedAt': datetime.datetime(2020, 6, 23, 7, 58, 6, 387000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 7, 58, 6, 357000), 'statusConnection': 'online', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'none', 'newMessageNotification': 'none', 'useEmojis': False, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'nothing', 'mobileNotifications': 'nothing', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': True, 'hideRoles': True, 'hideAvatars': True, 'hideFlexTab': False, 'highlights': [], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category', 'muteFocusedConversations': True, 'language': 'en', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarViewMode': 'condensed', 'sidebarHideAvatar': True, 'messageViewMode': 0, 'dontAskAgainList': [], 'desktopNotificationRequireInteraction': False, 'sidebarShowDiscussion': True}}, 'statusDefault': 'offline', 'requirePasswordChange': False, 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Robert Wuttke,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 17}, {'_id': 'uXGxXd39hr9dPfWDe', 'createdAt': datetime.datetime(2017, 7, 21, 19, 39, 31, 270000), 'services': {'password': {'bcrypt': '$2a$10$zuT/lIwA92WqDSbORF9V5O5xj1cKFYOF.hFJjuOmUOGRZeGI5wLfS'}, 'resume': {'loginTokens': []}}, 'username': 'sebastian', 'emails': [{'address': 'sebastian@copypixel.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': False, 'name': 'Sebastian An', '_updatedAt': datetime.datetime(2018, 7, 5, 23, 17, 47, 376000), 'roles': ['user'], 'lastLogin': datetime.datetime(2017, 10, 5, 8, 24, 8, 244000), 'statusConnection': 'offline', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': ['merge'], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category'}}, 'mapped_on': None, 'local_id': 18}, {'_id': 'wfLzhSsgvXujarkek', 'createdAt': datetime.datetime(2017, 9, 8, 10, 3, 43, 587000), 'services': {'password': {'bcrypt': '$2b$10$GeO9bv5ajrzfYqXXPx2EkOwXMw6SelbiGwQXndPzAnAjUIriidTL6'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 6, 7, 49, 13, 919000), 'hashedToken': 'QPUmtuLGSW1ext7/uw2v5sO/Y4y7Yaut6vtSpN9UuDk='}, {'when': datetime.datetime(2020, 4, 9, 9, 44, 6, 844000), 'hashedToken': 'TEoUg+hDbSPpm1xQeMPyUw8vwS3rJomqv5N1hmIDQJA='}, {'when': datetime.datetime(2020, 6, 12, 15, 7, 55, 114000), 'hashedToken': '+wmW/LkIfk2Rvq7Jj6so7k0fS+YMI+O7essdE87wJvA='}, {'when': datetime.datetime(2020, 6, 12, 15, 7, 55, 489000), 'hashedToken': 'iV+cjE+Tr9JiUN3WFVaodKEC7SsgCCZv5XRLfampIRU='}]}, 'ldap': {'id': '6c7363686965736c', 'idAttribute': 'uid'}}, 'username': 'lschiesl', 'emails': [{'address': 'lschiesl@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Lori Schiesl', '_updatedAt': datetime.datetime(2020, 6, 23, 5, 45, 37, 892000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 5, 43, 31, 628000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'ldap': True, 'settings': {'preferences': {'sidebarShowUnread': True, 'sidebarSortby': 'alphabetical'}}, 'avatarOrigin': 'upload', 'mapped_on': 'ldap:cn=Lori Schiesl,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 19}, {'_id': 'x55Jbr6r9v2Y3bsaw', 'createdAt': datetime.datetime(2017, 7, 21, 19, 36, 54, 419000), 'services': {'password': {'bcrypt': '$2b$10$4IqYED87Py4LVIwcbs3GbO3Fe6Ugsavp95w7CUfufDnPHNUhE6TLC'}, 'resume': {'loginTokens': [{'hashedToken': '/FAe9o7y+5CbrEzyo5h4SXjfu6KcpLKcRKGwOz2UYLM='}, {'hashedToken': 'zGeG49wUstqWEfomRhOSvAaayBP75ZP4V1WZX64QKBg='}, {'when': datetime.datetime(2020, 6, 2, 13, 19, 30, 595000), 'hashedToken': 'e9q8g6k8WnMeHrZG+xWKrjhm2zzFmWfh5B+b4oAFguY='}, {'when': datetime.datetime(2020, 6, 8, 6, 52, 35, 814000), 'hashedToken': 'D1yeURBM8MFluP6+Mkk5qTWQhC3rA0J6lmJO3R9lnOk='}]}, 'ldap': {'id': '69706f657365', 'idAttribute': 'uid'}}, 'username': 'ipoese', 'emails': [{'address': 'ipoese@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Ingmar Poese', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 29, 10, 534000), 'roles': ['user', 'admin', 'livechat-agent'], 'lastLogin': datetime.datetime(2020, 6, 23, 11, 28, 14, 599000), 'statusConnection': 'online', 'utcOffset': 2, 'settings': {'profile': {}, 'preferences': {'sidebarViewMode': 'condensed', 'sidebarGroupByType': True, 'sidebarShowDiscussion': True, 'sidebarSortby': 'alphabetical', 'sidebarHideAvatar': True}}, 'statusDefault': 'online', 'statusLivechat': 'not-available', 'operator': True, 'livechatCount': 1, 'requirePasswordChange': False, 'ldap': True, 'mapped_on': 'ldap:cn=Ingmar Poese,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 20}, {'_id': 'xcjBekoPAyqdJ2R3i', 'createdAt': datetime.datetime(2017, 8, 31, 12, 11, 52, 117000), 'services': {'password': {'bcrypt': '$2b$10$Epq5I6Td/WPUZ2lTu0P40uqsjMjGnaQ2YGjJzRiWhephO2dk9gYgi'}, 'resume': {'loginTokens': [{'hashedToken': 'L+gGnAPmT284vcMpQyUPleoYdZ3HHndtHWHVaVvbY+A='}, {'when': datetime.datetime(2020, 3, 30, 13, 50, 39, 701000), 'hashedToken': '1rGs0IEt8l1lA9ZY6VX7NmMlHXXFrXi5sY9+ZWbJJPY='}, {'when': datetime.datetime(2020, 4, 5, 12, 27, 31, 525000), 'hashedToken': 'j6UCcXDJwEojV1TKsQyE5W/MihpFgUj5lZ3tuBXxx78='}, {'when': datetime.datetime(2020, 4, 14, 8, 3, 46, 395000), 'hashedToken': '9hpKePMW+R7sZ52kONSiuAbtoIHzUw/BWkT3+3iEFDo='}, {'when': datetime.datetime(2020, 6, 16, 13, 25, 31, 111000), 'hashedToken': '950wo6jsQiCfZf4oJvAcZargusQEptvpcSVSxu+1hyQ='}]}, 'ldap': {'id': '736d657274656e73', 'idAttribute': 'uid'}}, 'username': 'smertens', 'emails': [{'address': 'smertens@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Stefan Mertens', '_updatedAt': datetime.datetime(2020, 6, 23, 6, 12, 31, 88000), 'roles': ['user', 'admin'], 'lastLogin': datetime.datetime(2020, 6, 23, 6, 12, 31, 54000), 'statusConnection': 'online', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': ['@stefan', 'stefan', '@smertens'], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category', 'sidebarViewMode': 'condensed', 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'statusDefault': 'online', 'operator': False, 'statusLivechat': 'not-available', 'livechatCount': 5, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Stefan Mertens,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 21}, {'_id': 'zxq7ffHL4SJRvSnd2', 'createdAt': datetime.datetime(2017, 7, 21, 15, 46, 2, 246000), 'services': {'password': {'bcrypt': '$2b$10$jmqsS8B9ei2rJRyj3ngW9.ldHXFYsitn1uoKLfYz0y4GfRgewSGtK'}, 'email': {'verificationTokens': [{'token': 'Ox4CEwr1kwv7ws3FGq2TINe_XZli3t21GEBVpCQE7hV', 'address': 'dlevin@benocs.com', 'when': datetime.datetime(2017, 7, 21, 15, 46, 2, 292000)}]}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 3, 19, 46, 35, 748000), 'hashedToken': 'L9Y1p4/nBnqV/gn4EnfS3Ip+/3+QR5q7bXmEdcyZMj8='}, {'when': datetime.datetime(2020, 5, 4, 7, 31, 13, 460000), 'hashedToken': 'Mbo+6dsjmZsIxvzSig7Aovf9b2RnCKFBBlKOEmHh1WU='}, {'when': datetime.datetime(2020, 5, 15, 10, 11, 2, 990000), 'hashedToken': 'voL593S/Plh3uL07ggVrY500myvucZRcaUna8t72AX8='}]}, 'ldap': {'id': '646c6576696e', 'idAttribute': 'uid'}}, 'emails': [{'address': 'dan@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Dan Levin', '_updatedAt': datetime.datetime(2020, 6, 23, 10, 44, 47, 732000), 'roles': ['admin', 'livechat-manager'], 'lastLogin': datetime.datetime(2020, 6, 23, 10, 30, 22, 750000), 'statusConnection': 'offline', 'utcOffset': 2, 'username': 'dlevin', 'statusDefault': 'away', 'settings': {'profile': {}, 'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'audioNotificationValue':' nan', 'desktopNotificationDuration': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': True, 'highlights': ['@dlevin', '@dan', 'dan', 'dlevin'], 'sendOnEnter': 'normal', 'sidebarViewMode': 'medium', 'sidebarSortby': 'alphabetical', 'sidebarShowFavorites': True, 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarGroupByType': True, 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}]}}, 'language': 'en', 'statusLivechat': 'not-available', 'operator': False, 'livechatCount': 16, 'user': {'settings': {'preferences': {'messageViewMode': 0}}}, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Dan Levin,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 22}, {'_id': 'zxq7ffHL4SJRvSnd2', 'createdAt': datetime.datetime(2017, 7, 21, 15, 46, 2, 246000), 'services': {'password': {'bcrypt': '$2b$10$jmqsS8B9ei2rJRyj3ngW9.ldHXFYsitn1uoKLfYz0y4GfRgewSGtK'}, 'email': {'verificationTokens': [{'token': 'Ox4CEwr1kwv7ws3FGq2TINe_XZli3t21GEBVpCQE7hV', 'address': 'dlevin@benocs.com', 'when': datetime.datetime(2017, 7, 21, 15, 46, 2, 292000)}]}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 3, 19, 46, 35, 748000), 'hashedToken': 'L9Y1p4/nBnqV/gn4EnfS3Ip+/3+QR5q7bXmEdcyZMj8='}, {'when': datetime.datetime(2020, 5, 4, 7, 31, 13, 460000), 'hashedToken': 'Mbo+6dsjmZsIxvzSig7Aovf9b2RnCKFBBlKOEmHh1WU='}, {'when': datetime.datetime(2020, 5, 15, 10, 11, 2, 990000), 'hashedToken': 'voL593S/Plh3uL07ggVrY500myvucZRcaUna8t72AX8='}]}, 'ldap': {'id': '646c6576696e', 'idAttribute': 'uid'}}, 'emails': [{'address': 'dan@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Dan Levin', '_updatedAt': datetime.datetime(2020, 6, 23, 10, 44, 47, 732000), 'roles': ['admin', 'livechat-manager'], 'lastLogin': datetime.datetime(2020, 6, 23, 10, 30, 22, 750000), 'statusConnection': 'offline', 'utcOffset': 2, 'username': 'dlevin', 'statusDefault': 'away', 'settings': {'profile': {}, 'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'audioNotificationValue':' nan', 'desktopNotificationDuration': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': True, 'highlights': ['@dlevin', '@dan', 'dan', 'dlevin'], 'sendOnEnter': 'normal', 'sidebarViewMode': 'medium', 'sidebarSortby': 'alphabetical', 'sidebarShowFavorites': True, 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarGroupByType': True, 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}]}}, 'language': 'en', 'statusLivechat': 'not-available', 'operator': False, 'livechatCount': 16, 'user': {'settings': {'preferences': {'messageViewMode': 0}}}, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Dan Levin,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 23}, {'_id': 'zxq7ffHL4SJRvSnd2', 'createdAt': datetime.datetime(2017, 7, 21, 15, 46, 2, 246000), 'services': {'password': {'bcrypt': '$2b$10$jmqsS8B9ei2rJRyj3ngW9.ldHXFYsitn1uoKLfYz0y4GfRgewSGtK'}, 'email': {'verificationTokens': [{'token': 'Ox4CEwr1kwv7ws3FGq2TINe_XZli3t21GEBVpCQE7hV', 'address': 'dlevin@benocs.com', 'when': datetime.datetime(2017, 7, 21, 15, 46, 2, 292000)}]}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 3, 19, 46, 35, 748000), 'hashedToken': 'L9Y1p4/nBnqV/gn4EnfS3Ip+/3+QR5q7bXmEdcyZMj8='}, {'when': datetime.datetime(2020, 5, 4, 7, 31, 13, 460000), 'hashedToken': 'Mbo+6dsjmZsIxvzSig7Aovf9b2RnCKFBBlKOEmHh1WU='}, {'when': datetime.datetime(2020, 5, 15, 10, 11, 2, 990000), 'hashedToken': 'voL593S/Plh3uL07ggVrY500myvucZRcaUna8t72AX8='}]}, 'ldap': {'id': '646c6576696e', 'idAttribute': 'uid'}}, 'emails': [{'address': 'dan@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Dan Levin', '_updatedAt': datetime.datetime(2020, 6, 23, 10, 44, 47, 732000), 'roles': ['admin', 'livechat-manager'], 'lastLogin': datetime.datetime(2020, 6, 23, 10, 30, 22, 750000), 'statusConnection': 'offline', 'utcOffset': 2, 'username': 'dlevin', 'statusDefault': 'away', 'settings': {'profile': {}, 'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'audioNotificationValue':' nan', 'desktopNotificationDuration': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': True, 'highlights': ['@dlevin', '@dan', 'dan', 'dlevin'], 'sendOnEnter': 'normal', 'sidebarViewMode': 'medium', 'sidebarSortby': 'alphabetical', 'sidebarShowFavorites': True, 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarGroupByType': True, 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}]}}, 'language': 'en', 'statusLivechat': 'not-available', 'operator': False, 'livechatCount': 16, 'user': {'settings': {'preferences': {'messageViewMode': 0}}}, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Dan Levin,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 24}, {'_id': 'ivwNbZBZwFKkB9F82', 'createdAt': datetime.datetime(2018, 8, 1, 13, 49, 42, 521000), 'services': {'password': {'bcrypt': '$2b$10$ZRgf/dyR/Fnmsl0y2s.pJe2Dx4DB.CUcZCk9Yv939lqPqZfVKEn4S'}, 'resume': {'loginTokens': [{'hashedToken': 'e+gpMrRSoKraATt1nvGN0lO23Hl5TH8mNFqzhaRsPUo='}, {'when': datetime.datetime(2020, 3, 31, 11, 8, 2, 801000), 'hashedToken': 'k7cUTNoiDGfmsGQ5rOgz4w49QQMGb88TElZBRMc4cy4='}, {'when': datetime.datetime(2020, 5, 7, 8, 48, 38, 370000), 'hashedToken': 'bqWVpYZ/uFT6Hq3TyZBKxZ8gHwJxTgK8vwLhT9itqB8='}, {'when': datetime.datetime(2020, 5, 19, 6, 25, 50, 219000), 'hashedToken': '0eBVJxNPTy3G9cZMqPp8pTrFtutKtvc8H7hX3RHmi3I='}, {'when': datetime.datetime(2020, 6, 8, 8, 14, 7, 195000), 'hashedToken': 'S3rkrkZBJI91T35l72oadUSznpyU8kLSPr7SdfTfWrA='}, {'when': datetime.datetime(2020, 6, 11, 12, 39, 47, 388000), 'hashedToken': 'ByPJ0csi90TltJfaIxVA3X7WaDP2JdAydFs/GJGQzjk='}, {'when': datetime.datetime(2020, 6, 22, 8, 54, 35, 352000), 'hashedToken': '1V/a0DD1P4BIe+dn0L88iXD5n6ehjpHTKRLCyaP03mM='}]}, 'ldap': {'id': '6f6b6f6c696e', 'idAttribute': 'uid'}}, 'username': 'okolin', 'emails': [{'address': 'okolin@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Ondrej Kolin', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 30, 16, 703000), 'roles': ['user', 'admin', 'bot'], 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarViewMode': 'medium'}}, 'lastLogin': datetime.datetime(2020, 6, 23, 11, 22, 52, 591000), 'statusConnection': 'offline', 'utcOffset': 2, 'language': '', 'ldap': True, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'statusDefault': 'online', 'mapped_on': 'zulip:okolin@benocs.com', 'local_id': 25}, {'_id': '4bXbRoJy2CpY7krSu', 'createdAt': datetime.datetime(2017, 8, 18, 12, 2, 28, 715000), 'services': {'password': {'bcrypt': '$2a$10$ezDefS0SKpjHYTvfoX0Kp.fQGqJrTAzd/ZTV43zljV5XaBjbS3ERe'}, 'resume': {'loginTokens': []}}, 'username': 'Oliver', 'emails': [{'address': 'oholschke@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Oliver Holschke', '_updatedAt': datetime.datetime(2019, 4, 16, 9, 40, 45, 240000), 'roles': ['user'], 'lastLogin': datetime.datetime(2019, 3, 28, 19, 15, 0, 421000), 'statusConnection': 'offline', 'utcOffset': 1, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Oliver Holschke,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 26}, {'_id': '6YZboSmMHktD3JDco', 'createdAt': datetime.datetime(2017, 8, 17, 11, 17, 16, 790000), 'services': {'password': {'bcrypt': '$2b$10$9R6/bM6mxmmeWMsEE0pIZebtSfTHGGYnMVrsk8/mAFUsFpP452LeW'}, 'resume': {'loginTokens': [{'hashedToken': 'vF7ON+FQ75tk30i0NWyAxmwI4nU4FhkF6Nmmos/gUMs='}, {'when': datetime.datetime(2020, 3, 27, 13, 7, 6, 127000), 'hashedToken': 'C37IiI4Ax/UXS3GTpP06bDQKyJ5O1bNMOII5mjZAAvc='}, {'when': datetime.datetime(2020, 4, 17, 6, 50, 27, 73000), 'hashedToken': '61XLizgArd7/ATYuHVhDa0OGNnuGJfZtDgTcsydSiXI='}, {'when': datetime.datetime(2020, 5, 11, 12, 14, 42, 697000), 'hashedToken': 'w76NrLYvNR/jPVPQMKYxzAK7LOxKspIdZ3H0j+h/yqo='}]}, 'ldap': {'id': '61766f67656c', 'idAttribute': 'uid'}}, 'username': 'avogel', 'emails': [{'address': 'avogel@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Arne Vogel', '_updatedAt': datetime.datetime(2020, 6, 17, 12, 34, 7, 125000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 17, 12, 33, 59, 823000), 'statusConnection': 'offline', 'utcOffset': 2, 'settings': {'profile': {}, 'preferences': {'newRoomNotification': 'none', 'newMessageNotification': 'none', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'avatarOrigin': 'upload', 'requirePasswordChange': False, 'language': '', 'ldap': True, 'mapped_on': 'ldap:cn=Arne Vogel,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 27}, {'_id': '9kHWRcrtX3MkBghsk', 'createdAt': datetime.datetime(2017, 8, 30, 9, 12, 56, 587000), 'services': {'password': {'bcrypt': '$2a$10$YbwZWBwwPEINWer5EOy11.ksmK45zp5JbwsUrm3Vmr4R0F/o4zB36'}, 'resume': {'loginTokens': []}}, 'username': 'Deniz', 'emails': [{'address': 'dbahadir@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Deniz Bahadir', '_updatedAt': datetime.datetime(2020, 5, 31, 9, 51, 29, 283000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 5, 25, 14, 56, 9, 810000), 'statusConnection': 'offline', 'utcOffset': 2, 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': [], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category'}}, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Deniz Bahadir,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 28}, {'_id': 'A7xGmTAevWFWHmn59', 'createdAt': datetime.datetime(2017, 9, 28, 13, 33, 18, 363000), 'services': {'password': {'bcrypt': '$2a$10$h1spqiy5J2cud5rfg1jxY.DG5.fYFx0trmGa4VCIQwfdoIljeYYJ.'}, 'resume': {'loginTokens': []}}, 'username': 'tim.korjakow', 'emails': [{'address': 'tim.korjakow@cct-ev.de', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Tim Korjakow', '_updatedAt': datetime.datetime(2018, 7, 5, 23, 17, 47, 376000), 'roles': ['guest'], 'lastLogin': datetime.datetime(2018, 1, 18, 22, 19, 49, 39000), 'statusConnection': 'offline', 'utcOffset': 1, 'settings': {'profile': {}}, 'avatarOrigin': 'upload', 'mapped_on': None, 'local_id': 29}, {'_id': 'AAPDaCDFJmKeR7zuh', 'createdAt': datetime.datetime(2017, 10, 10, 10, 57, 13, 221000), 'services': {'password': {'bcrypt': '$2a$10$bVl//BZauSR5wIAQz.vHYuOy.gvE4jq2kKYeslBfCQUhrV.0HKDCW'}, 'resume': {'loginTokens': []}}, 'username': 'Lisa', 'emails': [{'address': 'lkruse@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Lisa Kruse', '_updatedAt': datetime.datetime(2019, 6, 11, 7, 15, 57, 378000), 'roles': ['user'], 'lastLogin': datetime.datetime(2019, 4, 12, 10, 32, 50, 230000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Lisa Kruse,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 30}, {'_id': 'B6tSdyBJ5P7w5ADfi', 'createdAt': datetime.datetime(2017, 7, 21, 19, 37, 30, 889000), 'services': {'password': {'bcrypt': '$2a$10$OYATXYf7SqgcCx.SafVrWOJHNLYLjE1nA8gUb9SjEAFC1Z7Oeh3zO'}, 'resume': {'loginTokens': []}}, 'username': 'max', 'emails': [{'address': 'devnulll@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': False, 'name': 'Max Zwerenz', '_updatedAt': datetime.datetime(2018, 7, 5, 23, 17, 47, 376000), 'roles': ['user'], 'lastLogin': datetime.datetime(2017, 8, 2, 14, 4, 37, 648000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'mapped_on': None, 'local_id': 31}, {'_id': 'DD7YBqdhNheia49LS', 'createdAt': datetime.datetime(2017, 9, 28, 13, 32, 48, 264000), 'services': {'password': {'bcrypt': '$2a$10$5zAoyYXHhOZglGkSoGX7/u1yi9hXDSQPaCwo7E9/HhCI6IDnJcwqe'}, 'resume': {'loginTokens': []}}, 'username': 'max_e', 'emails': [{'address': 'maximilian.eissler@cct-ev.de', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Maximilian Eissler', '_updatedAt': datetime.datetime(2019, 6, 9, 14, 35, 56, 794000), 'roles': ['guest'], 'lastLogin': datetime.datetime(2019, 4, 26, 14, 10, 42, 969000), 'statusConnection': 'offline', 'utcOffset': 2, 'settings': {'profile': {}}, 'avatarOrigin': 'upload', 'mapped_on': None, 'local_id': 32}, {'_id': 'FNoqznDddTrjXggxc', 'createdAt': datetime.datetime(2019, 3, 4, 12, 47, 33, 567000), 'services': {'password': {'bcrypt': '$2b$10$MkdFO55N1d9Ze5mM5F0qGuOMHA1aw/tyMBeEUUnqvdbP7Av/FW.8C'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 25, 6, 52, 14, 504000), 'hashedToken': 'Gb6evgnWZgtKzNFitPDFfd+PVyHZBI+dG2lEB+bpktk='}]}, 'ldap': {'id': '64726562656c6f', 'idAttribute': 'uid'}}, 'username': 'drebelo', 'emails': [{'address': 'drebelo@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, '_updatedAt': datetime.datetime(2020, 6, 23, 6, 32, 28, 642000), 'roles': ['user'], 'name': 'Diana Rebelo Da Costa', 'settings': {}, 'lastLogin': datetime.datetime(2020, 6, 23, 6, 32, 28, 598000), 'statusConnection': 'online', 'utcOffset': 2, 'requirePasswordChange': False, 'ldap': True, 'statusDefault': 'offline', 'mapped_on': 'ldap:cn=Diana Rebelo da Costa,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 33}, {'_id': 'GWomsgueAb7Liy2Wx', 'createdAt': datetime.datetime(2020, 3, 6, 15, 9, 13, 200000), 'services': {'password': {'bcrypt': '$2b$10$XmX7MVAJLLieoRz9uDHRD.HPFsRCCKUqtBX4y0R5LFcbAQBDK2wAO'}, 'ldap': {'id': '74686f65686c6967', 'idAttribute': 'uid'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 6, 11, 10, 1, 816000), 'hashedToken': '0MfuSyRhFQruBQk+kmITmY2c153VOHuViLAZsXgJdYU='}, {'when': datetime.datetime(2020, 4, 21, 7, 14, 0, 157000), 'hashedToken': 'EOqTCFc6DbXxz7F6k30iHLs53KpRBWR6lUUVe4FbcGw='}, {'when': datetime.datetime(2020, 5, 14, 8, 52, 46, 992000), 'hashedToken': 'QTi7gp9yMPTmSNuhLsd5IWyGPKPXgxLCI7eCijTO+JY='}]}}, 'username': 'thoehlig', 'emails': [{'address': 'thoehlig@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, '_updatedAt': datetime.datetime(2020, 6, 23, 11, 32, 3, 49000), 'roles': ['user'], 'name': 'Thomas Höhlig', 'requirePasswordChange': False, 'settings': {}, 'ldap': True, 'lastLogin': datetime.datetime(2020, 6, 23, 11, 32, 2, 979000), 'statusConnection': 'online', 'utcOffset': 2, 'statusText': '', 'mapped_on': 'ldap:cn=Thomas Höhlig,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 34}, {'_id': 'PAv9tDN2YupHFGxGi', 'createdAt': datetime.datetime(2019, 5, 2, 7, 39, 27, 866000), 'services': {'password': {'bcrypt': '$2b$10$d0D1sLw683Cw4aZUpLsEK.C4YkA/W6mFRwxj2k.L/vHdpJxRqYjXe'}, 'ldap': {'id': '6a7a6572776173', 'idAttribute': 'uid'}, 'resume': {'loginTokens': []}, 'email': {'verificationTokens': []}}, 'username': 'jzerwas', 'emails': [{'address': 'jzerwas@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': False, '_updatedAt': datetime.datetime(2020, 2, 12, 10, 47, 59, 340000), 'roles': ['user'], 'ldap': True, 'lastLogin': datetime.datetime(2020, 2, 12, 8, 23, 59, 621000), 'statusConnection': 'offline', 'utcOffset': 1, 'name': 'Johannes Zerwas', 'requirePasswordChange': False, 'statusDefault': 'online', 'mapped_on': 'ldap:cn=Johannes Zerwas,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 35}, {'_id': 'RWmAHwKbyHdznNe8k', 'createdAt': datetime.datetime(2017, 9, 28, 13, 33, 49, 836000), 'services': {'password': {'bcrypt': '$2a$10$A9GrqwGAiHD/mIgbS3QWNOlr72UUkRKsid6yOmx5e7C4ulYSGHkLK'}, 'resume': {'loginTokens': []}}, 'username': 'duc.le', 'emails': [{'address': 'duc.le@cct-ev.de', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Duc Le', '_updatedAt': datetime.datetime(2018, 9, 26, 13, 51, 41, 47000), 'roles': ['guest'], 'lastLogin': datetime.datetime(2018, 6, 28, 13, 45, 16, 936000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'mapped_on': None, 'local_id': 36}, {'_id': 'TMNa74YiZPM4MsA7F', 'createdAt': datetime.datetime(2017, 9, 28, 13, 31, 58, 11000), 'services': {'password': {'bcrypt': '$2a$10$iyHskbSNaA9rqx1EiKz0UOjRL0WIAUejI6UVRYioifw6ZMMP7ADji'}, 'resume': {'loginTokens': []}}, 'username': 'Daniel.Neurath', 'emails': [{'address': 'daniel.neurath@cct-ev.de', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Daniel Neurath', '_updatedAt': datetime.datetime(2018, 7, 5, 23, 17, 47, 376000), 'roles': ['guest'], 'lastLogin': datetime.datetime(2018, 4, 5, 21, 28, 31, 296000), 'statusConnection': 'offline', 'utcOffset': 2, 'avatarOrigin': 'upload', 'requirePasswordChange': False, 'mapped_on': None, 'local_id': 37}, {'_id': 'Tf9jc9CsGoGqPRgJn', 'createdAt': datetime.datetime(2017, 8, 30, 9, 12, 25, 751000), 'services': {'password': {'bcrypt': '$2a$10$PuE1cpcBEYB01I7rQ06g3unATtpk/LZxCM.RsoSGY.yTubV4PaDg.'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 12, 12, 55, 53, 626000), 'hashedToken': 'aka6ezfy0uToghklSQjADb64ZygNIpGa0nt9xnj33Fs='}, {'when': datetime.datetime(2020, 5, 12, 14, 45, 50, 46000), 'hashedToken': 'DByrNDZugwfivkk7W0X5f+8vegK2PIma7kckyf2cJBU='}, {'when': datetime.datetime(2020, 5, 14, 8, 50, 34, 513000), 'hashedToken': 'Z7iVddKlBTe/RENTZolHRwkUfSSpny3mWo0AztHMkW8='}, {'when': datetime.datetime(2020, 5, 20, 12, 34, 4, 647000), 'hashedToken': 'WJIaugnN+ywUQfW+KKVhKJtifUg2z1Gl+ej4s4U9GKs='}]}}, 'username': 'Andrea', 'emails': [{'address': 'ajablonski@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Andrea Jablonski', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 6, 12, 169000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 11, 0, 5, 625000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'statusText': '', 'settings': {'profile': {}}, 'avatarOrigin': 'upload', 'statusDefault': 'online', 'mapped_on': 'ldap:cn=Andrea Jablonski,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 38}, {'_id': 'XB6cpvDpa38hNALsE', 'createdAt': datetime.datetime(2018, 7, 2, 12, 29, 16, 163000), 'services': {'password': {'bcrypt': '$2b$10$iY0u.VOiEDubzsFUzYCaZ.4CErmZI8LM79ovBj9zSUhLUOlWmWJYK'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 7, 7, 55, 6, 983000), 'hashedToken': '9UD5s6n9gMlACDLX4GUWXCXTbcKx32GYIobNNg4crWA='}, {'when': datetime.datetime(2020, 4, 17, 17, 0, 46, 927000), 'hashedToken': 'OF1zPXYZ9sy6q43cfh1dRqRTP0tX4BSBK1UEfeRSF90='}]}, 'ldap': {'id': '61726f656d6572', 'idAttribute': 'uid'}}, 'username': 'aroemer', 'emails': [{'address': 'aroemer@benocs.com', 'verified': True}], 'type': 'user', 'status': 'away', 'active': True, 'name': 'Axel Roemer', '_updatedAt': datetime.datetime(2020, 6, 23, 12, 8, 30, 860000), 'roles': ['user'], 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'nothing', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarShowDiscussion': True, 'sidebarViewMode': 'condensed', 'sidebarHideAvatar': False, 'sidebarShowFavorites': True, 'sidebarShowUnread': True}, 'profile': {}}, 'lastLogin': datetime.datetime(2020, 6, 23, 9, 0, 14, 959000), 'statusConnection': 'away', 'utcOffset': 2, 'language': '', 'statusDefault': 'online', 'requirePasswordChange': False, 'ldap': True, 'statusText': '', 'avatarOrigin': 'upload', 'mapped_on': 'ldap:cn=Axel Römer,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 39}, {'_id': 'au3sJqxqDy7xiMJsW', 'createdAt': datetime.datetime(2017, 8, 30, 9, 13, 22, 636000), 'services': {'password': {'bcrypt': '$2a$10$AzDx2SPL7mhcrmEHDSmKluQiK6MKey.vKL96zI/2AO7vSmRYlvh7G'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 29, 7, 52, 38, 364000), 'hashedToken': 'lyVBfPJenVHQ9M7j4HneW+OHb5na+FyBSbNvXOHb5fk='}, {'when': datetime.datetime(2020, 6, 18, 14, 51, 37, 705000), 'hashedToken': 'pytYazfo27ox16iieQl8WBMYfoLQK6BJYs4nTkMtGVE='}, {'when': datetime.datetime(2020, 6, 22, 6, 22, 5, 348000), 'hashedToken': 'wL6N8seIjxK8uXPpIlB76zvOjbGH1FBcDlPd7/80NA4='}, {'when': datetime.datetime(2020, 6, 22, 11, 15, 23, 744000), 'hashedToken': 'gpEg0CdZRae0oAMPbx54g6JilAjKvTBPiM4W1iKWxUA='}]}}, 'username': 'Hans', 'emails': [{'address': 'hseidel@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Hans Seidel', '_updatedAt': datetime.datetime(2020, 6, 23, 7, 57, 57, 353000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 7, 57, 57, 264000), 'statusConnection': 'online', 'utcOffset': 2, 'requirePasswordChange': False, 'settings': {'preferences': {'sidebarViewMode': 'medium', 'sidebarSortby': 'alphabetical', 'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'desktopNotificationDuration': 0, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'unreadAlert': True, 'sidebarShowDiscussion': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'language': '', 'mapped_on': 'ldap:cn=Hans Seidel,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 40}, {'_id': 'bv7DSiTZqnhT9w4Ss', 'createdAt': datetime.datetime(2018, 11, 30, 10, 2, 4, 245000), 'services': {'password': {'bcrypt': '$2b$10$7t/l03uyhozCQtqWQgU5d.R6KnitU9RZGmGWrNLRbwsjGsU5UShy.'}, 'resume': {'loginTokens': []}}, 'username': 'Falk', 'emails': [{'address': 'fbornstaedt@external.benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Falk von Bornstaedt', '_updatedAt': datetime.datetime(2020, 6, 14, 12, 11, 32, 702000), 'roles': ['guest'], 'settings': {}, 'lastLogin': datetime.datetime(2020, 6, 9, 14, 44, 48, 870000), 'statusConnection': 'offline', 'utcOffset': 1, 'mapped_on': 'ldap:cn=Falk Bornstaedt,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 41}, {'_id': 'cYn5zhNq2sQWrTssa', 'createdAt': datetime.datetime(2017, 8, 30, 9, 14, 6, 495000), 'services': {'password': {'bcrypt': '$2b$10$OCVjSHSIPjWbvce3Df.l0OfASV7pEsZPelcWyZCpSexiVOC5.uU9y'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 5, 8, 29, 36, 543000), 'hashedToken': 'TQJ+HDusTNBJtXi9nT+rZDBQItSaFC2sknXFauC3YNA='}, {'when': datetime.datetime(2020, 5, 14, 11, 17, 14, 604000), 'hashedToken': '9tFnIT2+Q0AULAVXnD5/XgV6TSvYlQms3h6G7VSYJB8='}, {'when': datetime.datetime(2020, 5, 14, 11, 36, 20, 946000), 'hashedToken': 'WxzcjSFi/1ePSBHcXdrPYvN3qntp3T8ioLCFhH8O1Nk='}, {'when': datetime.datetime(2020, 6, 9, 8, 24, 49, 859000), 'hashedToken': 'tDIZra74VmwXOAojgScIT1H3tGa+1ceHF9vIKmJkj6c='}]}, 'ldap': {'id': '6d6b616c69737a616e', 'idAttribute': 'uid'}}, 'username': 'mkaliszan', 'emails': [{'address': 'mkaliszan@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Michał Kaliszan', '_updatedAt': datetime.datetime(2020, 6, 23, 7, 57, 56, 460000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 7, 57, 56, 412000), 'statusConnection': 'online', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'roomsListExhibitionMode': 'category', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'all', 'mobileNotifications': 'all', 'audioNotificationValue':' nan', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': [], 'sendOnEnter': 'normal', 'muteFocusedConversations': True, 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'requirePasswordChange': False, 'statusDefault': 'online', 'ldap': True, 'mapped_on': 'ldap:cn=Michal Kaliszan,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 42}, {'_id': 'eRueyRuaSJTHW7Ea3', 'createdAt': datetime.datetime(2018, 11, 30, 10, 0, 1, 306000), 'services': {'password': {'bcrypt': '$2b$10$MSnUbTY2HBczD1JbDiA9y.OuOmdH5mgBvCQvBl0uoka9PdNoCZFtq'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 6, 4, 6, 41, 24, 550000), 'hashedToken': '0VwmtiJJ5nGxLwZELusRazv62feuxcnRxQRJO+TnY0s='}, {'when': datetime.datetime(2020, 6, 4, 6, 46, 7, 780000), 'hashedToken': '8pCm4nFQrErck0QCThjCxhMarhkx7VY4AVcK11gF/Xw='}]}}, 'username': 'Ulrich', 'emails': [{'address': 'uhammerschmidt@external.benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Ulrich Hammerschmidt', '_updatedAt': datetime.datetime(2020, 6, 23, 10, 36, 12, 276000), 'roles': ['guest'], 'settings': {}, 'lastLogin': datetime.datetime(2020, 6, 23, 10, 36, 11, 541000), 'statusConnection': 'online', 'utcOffset': 2, 'statusDefault': 'online', 'mapped_on': 'ldap:cn=Ulrich Hammerschmidt,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 43}, {'_id': 'gsKLNsqdhodg9k5km', 'createdAt': datetime.datetime(2017, 8, 15, 14, 31, 0, 57000), 'services': {'password': {'bcrypt': '$2b$10$1YPYPXeZZsqPoj1fWpWDk.ZMh.fvj6jtG8aXxMO54epOiIGXiXAiC'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 25, 10, 1, 53, 861000), 'hashedToken': 'bVzOtnvPXWyXTF5J4Xl4549PEkhpPKP+gpnbxzYyN3g='}]}}, 'username': 'epujol', 'emails': [{'address': 'enric@benocs.com', 'verified': True}], 'type': 'user', 'status': 'away', 'active': True, 'name': 'Enric Pujol', '_updatedAt': datetime.datetime(2020, 6, 23, 12, 2, 31, 353000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 9, 12, 7, 882000), 'statusConnection': 'away', 'utcOffset': 2, 'statusDefault': 'online', 'requirePasswordChange': False, 'ldap': True, 'settings': {'preferences': {'sidebarViewMode': 'condensed', 'dontAskAgainList': [{'action': 'hideRoom', 'label': 'Hide Room'}], 'autoImageLoad': True, 'collapseMediaByDefault': False, 'convertAsciiEmoji': True, 'desktopNotificationDuration': 0, 'desktopNotificationRequireInteraction': False, 'desktopNotifications': 'mentions', 'emailNotificationMode': 'nothing', 'enableAutoAway': False, 'hideAvatars': False, 'hideFlexTab': False, 'hideRoles': False, 'hideUsernames': False, 'highlights': [], 'idleTimeLimit': 300, 'language': '', 'messageViewMode': 0, 'mobileNotifications': 'all', 'muteFocusedConversations': True, 'newMessageNotification': 'chime', 'newRoomNotification': 'door', 'notificationsSoundVolume': 100, 'saveMobileBandwidth': True, 'sendOnEnter': 'normal', 'sidebarHideAvatar': False, 'sidebarShowDiscussion': True, 'unreadAlert': False, 'useEmojis': True}}, 'language': '', 'mapped_on': 'ldap:cn=Enric Pujol,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 44}, {'_id': 'j2Gr8fWHAJE33Wnvp', 'createdAt': datetime.datetime(2018, 8, 31, 8, 35, 7, 526000), 'services': {'password': {'bcrypt': '$2b$10$M3zlYtzbs4/G85K9JrA/jurc3kMimGpKxPV4EWjdfjWdzqzqtQywS'}, 'resume': {'loginTokens': [{'hashedToken': 'GJUYwlO9WAomywHJq55z/hXbwh9Uk28oPpXhal0yX6E='}, {'when': datetime.datetime(2020, 3, 26, 7, 38, 12, 337000), 'hashedToken': 'VX66x54ojeXk2T81yFrOlELlF5ZpZN+5GhNGQENa+Vs='}, {'when': datetime.datetime(2020, 4, 27, 8, 37, 28, 490000), 'hashedToken': 'hISbmEPoxJX/krLNx8aqt4LNtCU3i3erIo05vYRA4F8='}]}}, 'username': 'Stephan', 'emails': [{'address': 'sschroeder@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Stephan Schröder', '_updatedAt': datetime.datetime(2020, 6, 23, 9, 13, 0, 241000), 'roles': ['user'], 'settings': {'preferences': {'sidebarViewMode': 'condensed', 'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'muteFocusedConversations': True, 'hideUsernames': False, 'messageViewMode': 0, 'hideFlexTab': False, 'hideAvatars': False, 'sendOnEnter': 'normal', 'autoImageLoad': True, 'emailNotificationMode': 'nothing', 'desktopNotificationDuration': 0, 'desktopNotifications': 'all', 'mobileNotifications': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'highlights': [], 'dontAskAgainList': [], 'hideRoles': False, 'language': '', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarShowUnread': True}}, 'lastLogin': datetime.datetime(2020, 6, 23, 9, 13, 0, 174000), 'statusConnection': 'online', 'utcOffset': 2, 'language': '', 'avatarOrigin': 'upload', 'statusDefault': 'online', 'mapped_on': 'ldap:cn=Stephan Schröder,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 45}, {'_id': 'rH2RYKXCBmpy22gQy', 'createdAt': datetime.datetime(2017, 7, 21, 19, 38, 38, 75000), 'services': {'password': {'bcrypt': '$2b$10$mJtAnWzvfb9NwAPRLLzv7OFMfuuau587Tx3JgEGSaTyU5tLM4vcWC'}, 'resume': {'loginTokens': [{'hashedToken': 'WV7JtVZRcUqSektXPraQOmYJbSKk1W65/rPmP8880gI='}, {'when': datetime.datetime(2020, 5, 14, 7, 23, 13, 403000), 'hashedToken': 'ruT4mcUpnqWnnaYxS8717QuehKxmJtRMk2ZWHQsEJr8='}, {'when': datetime.datetime(2020, 5, 26, 17, 35, 48, 512000), 'hashedToken': 'TLMS7UHKs4z8damWaPk+KUFWwpR9hmRb0YHQlCtluPc='}, {'when': datetime.datetime(2020, 6, 17, 13, 2, 48, 258000), 'hashedToken': '7CWQzlUgHBfCThsjIzmHo2kPYaF3pRaC935ElxywWqw='}]}, 'ldap': {'id': '70757262616e696b', 'idAttribute': 'uid'}}, 'username': 'purbanik', 'emails': [{'address': 'purbanik@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Phillip Urbanik', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 45, 16, 778000), 'roles': ['user', 'livechat-manager', 'livechat-agent'], 'lastLogin': datetime.datetime(2020, 6, 23, 11, 45, 16, 727000), 'statusConnection': 'online', 'utcOffset': 2, 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'nothing', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': ['@purbanik', '@phillip'], 'sendOnEnter': 'normal', 'sidebarSortby': 'alphabetical', 'sidebarShowUnread': True, 'sidebarShowFavorites': True, 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarShowDiscussion': True, 'dontAskAgainList': []}}, 'language': 'en', 'requirePasswordChange': False, 'operator': True, 'statusLivechat': 'not-available', 'livechatCount': 30, 'statusDefault': 'online', 'avatarOrigin': 'upload', 'ldap': True, 'mapped_on': 'ldap:cn=Phillip Urbanik,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 46}, {'_id': 'rocket.cat', 'createdAt': datetime.datetime(2017, 7, 21, 15, 44, 51, 957000), 'avatarOrigin': 'upload', 'name': 'Benocs Bot', 'username': 'Benocsbot', 'status': 'offline', 'statusDefault': 'online', 'utcOffset': 1, 'active': True, 'type': 'bot', '_updatedAt': datetime.datetime(2020, 3, 3, 13, 35, 7, 958000), 'roles': ['bot'], 'emails': [{'address': 'benocsbot@benocs.com', 'verified': True}], 'services': {'password': {'bcrypt': '$2a$10$g.Tiq04Or6PKGQ7yRmih4utVaOi0Nhlb3dVh7u.p3mYhmd0.Q8nl.'}, 'resume': {'loginTokens': []}}, 'requirePasswordChange': False, 'lastLogin': datetime.datetime(2018, 5, 24, 2, 1, 20, 985000), 'statusConnection': 'offline', 'mapped_on': None, 'local_id': 47}, {'_id': 'tL97yy2CNRTj2bR2m', 'createdAt': datetime.datetime(2017, 9, 28, 13, 31, 21, 404000), 'services': {'password': {'bcrypt': '$2a$10$Kk0KtVJ7NQ6PuvPVO2PFuuL2ysemx46FGDuA0ZCtfGTv4VAW1BqJq'}, 'resume': {'loginTokens': []}}, 'username': 'junzhe', 'emails': [{'address': 'jun-zhe.lai@cct-ev.de', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Jun-Zhe Lai', '_updatedAt': datetime.datetime(2019, 5, 18, 19, 20, 44, 906000), 'roles': ['guest'], 'lastLogin': datetime.datetime(2019, 3, 25, 14, 0, 41, 670000), 'statusConnection': 'offline', 'utcOffset': 1, 'avatarOrigin': 'url', 'settings': {'preferences': {'sidebarViewMode': 'medium'}}, 'statusDefault': 'busy', 'mapped_on': None, 'local_id': 48}, {'_id': 'tTZrHZ28gWKk7oXDw', 'createdAt': datetime.datetime(2017, 8, 23, 13, 21, 25, 641000), 'services': {'password': {'bcrypt': '$2b$10$nQywJ5uiyCS.8t2nLEGqYOXyKRIuROWHxVGKAcsyYl2fSSalE3PeS'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 5, 7, 13, 2, 32, 93000), 'hashedToken': 'ZuviXpIjtMfAVQp44O5itFxoEfMqLR5q7/3V7cplxDs='}, {'when': datetime.datetime(2020, 5, 14, 11, 39, 11, 327000), 'hashedToken': '5JUqHIi03GnE3kkaczcknoTLyOhR3RzJFijSoovUFnQ='}, {'when': datetime.datetime(2020, 5, 14, 11, 39, 44, 234000), 'hashedToken': '14tA0K5Csa+fGZwHb4fmBmMqX3BoXfVW5vReQ2xhZPk='}, {'when': datetime.datetime(2020, 5, 15, 11, 52, 37, 773000), 'hashedToken': 'H/cA8TkTOu4Ph/Vik1XqhLV5DW1CgDzG878QNbwCNNc='}]}, 'ldap': {'id': '72777574746b65', 'idAttribute': 'uid'}}, 'username': 'rwuttke', 'emails': [{'address': 'robert@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Robert Wuttke', '_updatedAt': datetime.datetime(2020, 6, 23, 7, 58, 6, 387000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 7, 58, 6, 357000), 'statusConnection': 'online', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'none', 'newMessageNotification': 'none', 'useEmojis': False, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'default', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'nothing', 'mobileNotifications': 'nothing', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': True, 'hideRoles': True, 'hideAvatars': True, 'hideFlexTab': False, 'highlights': [], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category', 'muteFocusedConversations': True, 'language': 'en', 'enableAutoAway': False, 'idleTimeLimit': 300, 'sidebarViewMode': 'condensed', 'sidebarHideAvatar': True, 'messageViewMode': 0, 'dontAskAgainList': [], 'desktopNotificationRequireInteraction': False, 'sidebarShowDiscussion': True}}, 'statusDefault': 'offline', 'requirePasswordChange': False, 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Robert Wuttke,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 49}, {'_id': 'u5PSXF4KgfkWsvcpt', 'createdAt': datetime.datetime(2018, 11, 30, 10, 1, 19, 553000), 'services': {'password': {'bcrypt': '$2b$10$KQw6M9t92QcuHBPQVBYjneQrYawMZIQ4QEVHJTqAgBNnMOlUG65Ti'}, 'resume': {'loginTokens': []}}, 'username': 'smondal', 'emails': [{'address': 'smondal@external.benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Shankar Mondal', '_updatedAt': datetime.datetime(2019, 6, 30, 10, 50, 45, 965000), 'roles': ['guest'], 'settings': {}, 'lastLogin': datetime.datetime(2019, 4, 12, 5, 48, 30, 546000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'mapped_on': 'ldap:cn=Shankar Mondal,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 50}, {'_id': 'uXGxXd39hr9dPfWDe', 'createdAt': datetime.datetime(2017, 7, 21, 19, 39, 31, 270000), 'services': {'password': {'bcrypt': '$2a$10$zuT/lIwA92WqDSbORF9V5O5xj1cKFYOF.hFJjuOmUOGRZeGI5wLfS'}, 'resume': {'loginTokens': []}}, 'username': 'sebastian', 'emails': [{'address': 'sebastian@copypixel.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': False, 'name': 'Sebastian An', '_updatedAt': datetime.datetime(2018, 7, 5, 23, 17, 47, 376000), 'roles': ['user'], 'lastLogin': datetime.datetime(2017, 10, 5, 8, 24, 8, 244000), 'statusConnection': 'offline', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': ['merge'], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category'}}, 'mapped_on': None, 'local_id': 51}, {'_id': 'wfLzhSsgvXujarkek', 'createdAt': datetime.datetime(2017, 9, 8, 10, 3, 43, 587000), 'services': {'password': {'bcrypt': '$2b$10$GeO9bv5ajrzfYqXXPx2EkOwXMw6SelbiGwQXndPzAnAjUIriidTL6'}, 'resume': {'loginTokens': [{'when': datetime.datetime(2020, 4, 6, 7, 49, 13, 919000), 'hashedToken': 'QPUmtuLGSW1ext7/uw2v5sO/Y4y7Yaut6vtSpN9UuDk='}, {'when': datetime.datetime(2020, 4, 9, 9, 44, 6, 844000), 'hashedToken': 'TEoUg+hDbSPpm1xQeMPyUw8vwS3rJomqv5N1hmIDQJA='}, {'when': datetime.datetime(2020, 6, 12, 15, 7, 55, 114000), 'hashedToken': '+wmW/LkIfk2Rvq7Jj6so7k0fS+YMI+O7essdE87wJvA='}, {'when': datetime.datetime(2020, 6, 12, 15, 7, 55, 489000), 'hashedToken': 'iV+cjE+Tr9JiUN3WFVaodKEC7SsgCCZv5XRLfampIRU='}]}, 'ldap': {'id': '6c7363686965736c', 'idAttribute': 'uid'}}, 'username': 'lschiesl', 'emails': [{'address': 'lschiesl@benocs.com', 'verified': True}], 'type': 'user', 'status': 'offline', 'active': True, 'name': 'Lori Schiesl', '_updatedAt': datetime.datetime(2020, 6, 23, 5, 45, 37, 892000), 'roles': ['user'], 'lastLogin': datetime.datetime(2020, 6, 23, 5, 43, 31, 628000), 'statusConnection': 'offline', 'utcOffset': 2, 'requirePasswordChange': False, 'ldap': True, 'settings': {'preferences': {'sidebarShowUnread': True, 'sidebarSortby': 'alphabetical'}}, 'avatarOrigin': 'upload', 'mapped_on': 'ldap:cn=Lori Schiesl,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 52}, {'_id': 'x55Jbr6r9v2Y3bsaw', 'createdAt': datetime.datetime(2017, 7, 21, 19, 36, 54, 419000), 'services': {'password': {'bcrypt': '$2b$10$4IqYED87Py4LVIwcbs3GbO3Fe6Ugsavp95w7CUfufDnPHNUhE6TLC'}, 'resume': {'loginTokens': [{'hashedToken': '/FAe9o7y+5CbrEzyo5h4SXjfu6KcpLKcRKGwOz2UYLM='}, {'hashedToken': 'zGeG49wUstqWEfomRhOSvAaayBP75ZP4V1WZX64QKBg='}, {'when': datetime.datetime(2020, 6, 2, 13, 19, 30, 595000), 'hashedToken': 'e9q8g6k8WnMeHrZG+xWKrjhm2zzFmWfh5B+b4oAFguY='}, {'when': datetime.datetime(2020, 6, 8, 6, 52, 35, 814000), 'hashedToken': 'D1yeURBM8MFluP6+Mkk5qTWQhC3rA0J6lmJO3R9lnOk='}]}, 'ldap': {'id': '69706f657365', 'idAttribute': 'uid'}}, 'username': 'ipoese', 'emails': [{'address': 'ipoese@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Ingmar Poese', '_updatedAt': datetime.datetime(2020, 6, 23, 11, 29, 10, 534000), 'roles': ['user', 'admin', 'livechat-agent'], 'lastLogin': datetime.datetime(2020, 6, 23, 11, 28, 14, 599000), 'statusConnection': 'online', 'utcOffset': 2, 'settings': {'profile': {}, 'preferences': {'sidebarViewMode': 'condensed', 'sidebarGroupByType': True, 'sidebarShowDiscussion': True, 'sidebarSortby': 'alphabetical', 'sidebarHideAvatar': True}}, 'statusDefault': 'online', 'statusLivechat': 'not-available', 'operator': True, 'livechatCount': 1, 'requirePasswordChange': False, 'ldap': True, 'mapped_on': 'ldap:cn=Ingmar Poese,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 53}, {'_id': 'xcjBekoPAyqdJ2R3i', 'createdAt': datetime.datetime(2017, 8, 31, 12, 11, 52, 117000), 'services': {'password': {'bcrypt': '$2b$10$Epq5I6Td/WPUZ2lTu0P40uqsjMjGnaQ2YGjJzRiWhephO2dk9gYgi'}, 'resume': {'loginTokens': [{'hashedToken': 'L+gGnAPmT284vcMpQyUPleoYdZ3HHndtHWHVaVvbY+A='}, {'when': datetime.datetime(2020, 3, 30, 13, 50, 39, 701000), 'hashedToken': '1rGs0IEt8l1lA9ZY6VX7NmMlHXXFrXi5sY9+ZWbJJPY='}, {'when': datetime.datetime(2020, 4, 5, 12, 27, 31, 525000), 'hashedToken': 'j6UCcXDJwEojV1TKsQyE5W/MihpFgUj5lZ3tuBXxx78='}, {'when': datetime.datetime(2020, 4, 14, 8, 3, 46, 395000), 'hashedToken': '9hpKePMW+R7sZ52kONSiuAbtoIHzUw/BWkT3+3iEFDo='}, {'when': datetime.datetime(2020, 6, 16, 13, 25, 31, 111000), 'hashedToken': '950wo6jsQiCfZf4oJvAcZargusQEptvpcSVSxu+1hyQ='}]}, 'ldap': {'id': '736d657274656e73', 'idAttribute': 'uid'}}, 'username': 'smertens', 'emails': [{'address': 'smertens@benocs.com', 'verified': True}], 'type': 'user', 'status': 'online', 'active': True, 'name': 'Stefan Mertens', '_updatedAt': datetime.datetime(2020, 6, 23, 6, 12, 31, 88000), 'roles': ['user', 'admin'], 'lastLogin': datetime.datetime(2020, 6, 23, 6, 12, 31, 54000), 'statusConnection': 'online', 'utcOffset': 2, 'language': 'en', 'settings': {'preferences': {'newRoomNotification': 'door', 'newMessageNotification': 'chime', 'useEmojis': True, 'convertAsciiEmoji': True, 'saveMobileBandwidth': True, 'collapseMediaByDefault': False, 'autoImageLoad': True, 'emailNotificationMode': 'mentions', 'unreadAlert': True, 'notificationsSoundVolume': 100, 'desktopNotifications': 'default', 'mobileNotifications': 'default', 'desktopNotificationDuration': 0, 'viewMode': 0, 'hideUsernames': False, 'hideRoles': False, 'hideAvatars': False, 'hideFlexTab': False, 'highlights': ['@stefan', 'stefan', '@smertens'], 'sendOnEnter': 'normal', 'roomsListExhibitionMode': 'category', 'sidebarViewMode': 'condensed', 'muteFocusedConversations': True, 'messageViewMode': 0, 'enableAutoAway': False, 'idleTimeLimit': 300}}, 'statusDefault': 'online', 'operator': False, 'statusLivechat': 'not-available', 'livechatCount': 5, 'requirePasswordChange': False, 'avatarOrigin': 'upload', 'ldap': True, 'statusText': '', 'mapped_on': 'ldap:cn=Stefan Mertens,ou=people,l=Berlin,dc=benocs,dc=com', 'local_id': 54}]
    solve_profile_mapping(user_profiles,cw)
    return user_profiles
    # # Set the mapping for the rocket.chat to zulip - stream/topic
    # stream = select_stream(zulip_client, cw)
    # topic = ""
    # while topic == "":
    #     topic = read_curses_string("Set the topic name", cw, clear=True)
    # cw.clear()
    # cw.addstr(f"Importing into {stream['name']}/{topic}")
    # cw.getch()

# Run the curses runner
x = curses.wrapper(main)